
User Interface - Feature #2894

Implement browse multiple selection with Shift and Ctrl keys

12/01/2015 05:34 PM - Stanislav Lomany

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Stanislav Lomany % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: Cleanup and Stabilization for GUI   

billable: No vendor_id: GCD

Description

Related issues:

Related to User Interface - Feature #2564: implement GUI BROWSE widget Closed

History

#1 - 07/21/2016 05:35 PM - Stanislav Lomany

- Status changed from New to WIP

Guys, as far as I get we don't have a way to figure out if a key is held down (or released)?

#2 - 07/22/2016 05:01 AM - Hynek Cihlar

Stanislav Lomany wrote:

Guys, as far as I get we don't have a way to figure out if a key is held down (or released)?

 

No we don't. Currently you can only get type-events for some of the special keys (Ctrl, Alt, Shift).

#3 - 07/22/2016 05:16 AM - Greg Shah

Don't we just need to know if these modifier keys are on at the time the mouse is clicked on a row?  I imagine there may be some other cursor key

movement and a space or enter key that could also be used?

Please describe the functionality that must be implemented.

#4 - 07/22/2016 06:21 AM - Stanislav Lomany

Never mind, ctrl and shift modifiers can be found in MouseEvent.

The functionality is:

On ctrl+click: add/remove row to/from the set of selected rows.

On shift+click: set the rows from the current row to the clicked row as the set of selected rows.
#5 - 07/22/2016 09:22 AM - Stanislav Lomany

Created task branch 2894a from trunk revision 11072.

#6 - 07/22/2016 12:10 PM - Stanislav Lomany

Please review task branch 2894a revision 11073.

#7 - 07/24/2016 08:53 AM - Greg Shah

Code Review Task Branch 2894a Revision 11073

The changes are fine.

Did you test this on both the web client and the Swing client?

#8 - 07/25/2016 02:44 PM - Stanislav Lomany

It doesn't work in web client.

Sergey, can you update MouseEvent.modifiers when Ctrl or Shift is held? My experience with javascript part is very limited.

#9 - 07/25/2016 03:11 PM - Sergey Ivanovskiy

Stanislav Lomany wrote:

It doesn't work in web client.

Sergey, can you update MouseEvent.modifiers when Ctrl or Shift is held? My experience with javascript part is very limited.

 

It seems that Window.prototype.sendMouseEvent sets Ctrl, Shift and Alt modifiers for a mouse event. I should check it against 2894.

#10 - 07/25/2016 04:26 PM - Sergey Ivanovskiy

- File modifiers_diff.txt added

Stanislav, please apply and review this diff. patch -p0 < modifiers_diff.txt

#11 - 07/25/2016 04:42 PM - Sergey Ivanovskiy

Modified: Checked ./browse/gui/browse-gui-stat1.p against the Web client (2894a) and encountered this exception clicking on the browser's scrolling

button

DRAW: Ignoring event com.goldencode.p2j.ui.client.event.PaintEvent 9 raised while drawing widget com.goldencod

e.p2j.ui.client.gui.ScrollBarGuiButton with id [-30].

Jul 25, 2016 11:34:24 PM Dispatcher.processInbound() 

SEVERE: {main} Unexpected throwable.

java.lang.reflect.InvocationTargetException

    at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)

    at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)

    at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)

    at java.lang.reflect.Method.invoke(Method.java:498)
    at com.goldencode.p2j.util.MethodInvoker.invoke(MethodInvoker.java:76)

    at com.goldencode.p2j.net.Dispatcher.processInbound(Dispatcher.java:705)

    at com.goldencode.p2j.net.Conversation.block(Conversation.java:364)

    at com.goldencode.p2j.net.Conversation.waitMessage(Conversation.java:300)

    at com.goldencode.p2j.net.Queue.transactImpl(Queue.java:1141)

    at com.goldencode.p2j.net.Queue.transact(Queue.java:598)

    at com.goldencode.p2j.net.BaseSession.transact(BaseSession.java:223)

    at com.goldencode.p2j.net.HighLevelObject.transact(HighLevelObject.java:163)

    at com.goldencode.p2j.net.RemoteObject$RemoteAccess.invokeCore(RemoteObject.java:1425)

    at com.goldencode.p2j.net.InvocationStub.invoke(InvocationStub.java:97)

    at com.sun.proxy.$Proxy11.standardEntry(Unknown Source)

    at com.goldencode.p2j.main.ClientCore.start(ClientCore.java:294)

    at com.goldencode.p2j.main.ClientCore.start(ClientCore.java:104)

    at com.goldencode.p2j.main.ClientDriver.start(ClientDriver.java:202)

    at com.goldencode.p2j.main.CommonDriver.process(CommonDriver.java:396)

    at com.goldencode.p2j.main.ClientDriver.process(ClientDriver.java:96)

    at com.goldencode.p2j.main.ClientDriver.main(ClientDriver.java:265)

Caused by: java.lang.ArrayIndexOutOfBoundsException: -7

    at com.goldencode.p2j.ui.client.Browse.getCachedRowNumber(Browse.java:523)

    at com.goldencode.p2j.ui.client.Browse.scrollToRow(Browse.java:5452)

    at com.goldencode.p2j.ui.client.gui.BrowseGuiImpl.access$4400(BrowseGuiImpl.java:57)

    at com.goldencode.p2j.ui.client.gui.BrowseGuiImpl$VerticalRowScroller.positionUpdated(BrowseGuiImpl.java:3

328)

    at com.goldencode.p2j.ui.client.ScrollBar.onButtonClick(ScrollBar.java:345)

    at com.goldencode.p2j.ui.client.gui.ScrollBarGuiImpl.onButtonClick(ScrollBarGuiImpl.java:911)

    at com.goldencode.p2j.ui.client.gui.ScrollBarGuiImpl.mouseClicked(ScrollBarGuiImpl.java:602)

    at com.goldencode.p2j.ui.client.gui.driver.MouseHandler.applyMouseEvent(MouseHandler.java:321)

    at com.goldencode.p2j.ui.client.gui.driver.MouseHandler.handleMouseEvent(MouseHandler.java:239)

    at com.goldencode.p2j.ui.client.gui.driver.AbstractGuiDriver.handleMouseEvent(AbstractGuiDriver.java:2566)

    at com.goldencode.p2j.ui.client.TopLevelWindow.processEvent(TopLevelWindow.java:717)

    at com.goldencode.p2j.ui.client.gui.WindowGuiImpl.processEvent(WindowGuiImpl.java:1306)

    at com.goldencode.p2j.ui.chui.ThinClient.processProgressEvent(ThinClient.java:15811)

    at com.goldencode.p2j.ui.chui.ThinClient.processEventsWorker(ThinClient.java:15438)

    at com.goldencode.p2j.ui.chui.ThinClient.pop(ThinClient.java:14444)

    at com.goldencode.p2j.ui.chui.ThinClient.eventBracket(ThinClient.java:14427)

    at com.goldencode.p2j.ui.chui.ThinClient.eventDrawingBracket(ThinClient.java:14345)

    at com.goldencode.p2j.ui.chui.ThinClient.applyWorker(ThinClient.java:14101)

    at com.goldencode.p2j.ui.chui.ThinClient.waitForWorker(ThinClient.java:11378)

    at com.goldencode.p2j.ui.chui.ThinClient.waitForWorker(ThinClient.java:10883)

    at com.goldencode.p2j.ui.chui.ThinClient.waitFor(ThinClient.java:10831)

    at com.goldencode.p2j.ui.chui.ThinClient.waitFor(ThinClient.java:10785)

    ... 21 more
#12 - 07/25/2016 04:44 PM - Stanislav Lomany

Thank you! Ctrl and Shift events work properly. I'll look into ArrayIndexOutOfBoundsException.

#13 - 07/25/2016 04:47 PM - Sergey Ivanovskiy

I can't reproduce it now. It seems that it is not a regular exception.

#14 - 07/25/2016 04:52 PM - Sergey Ivanovskiy

I can reproduce it. It needs to move the thumb button down and then click on the scroll bar between the upper scroll bar's button and thumb button. It

can be reproduced for the Swing client too.

#15 - 07/25/2016 04:55 PM - Stanislav Lomany

Awesome! I see it too.

#16 - 07/26/2016 06:05 AM - Stanislav Lomany

Browse scrolling was implemented at the time when there was no ability to click between the thumb and a scrollbar button. Vadim made this

functionality work to a certain extent when this ability was added, but neither horizontal nor vertical scrolling work accurately. I'm working on it.

#17 - 07/31/2016 08:03 AM - Stanislav Lomany

Task brank 2894a rebased to trunk revision 11074.

#18 - 07/31/2016 08:19 AM - Stanislav Lomany

Please review task branch 2894a revision 11079.

#19 - 08/01/2016 10:16 AM - Greg Shah

Code Review Task Branch 2894a Revision 11079

Generally the changes look good.  My only question:

In BrowseGuiImpl.HorizontalColumnScroller.positionUpdated(), there is this code (line 3170):

      if (position == oldPosition || colNo == 0 || config.numLockedColumns == colNo)

 

I'm wondering if the config.numLockedColumns == colNo should be changed to colNo <= config.numLockedColumns or even colNo <

config.numLockedColumns (since config.numLockedColumns is zero-based)?

#20 - 08/01/2016 12:14 PM - Stanislav Lomany

Yes, that adds even more safety. I'll regression test for the case.

#21 - 08/03/2016 11:47 AM - Stanislav Lomany

Regression testing passed. Should I commit?

#22 - 08/03/2016 12:52 PM - Greg Shah
Go ahead.

#23 - 08/03/2016 02:25 PM - Stanislav Lomany

- Status changed from WIP to Review

Task branch 2894a merged to trunk as revision 11075.

#24 - 08/03/2016 03:05 PM - Greg Shah

- % Done changed from 0 to 100

- Start date deleted (12/01/2015)

- Target version set to Milestone 16

- Status changed from Review to Closed

#25 - 11/16/2016 12:22 PM - Greg Shah

- Target version changed from Milestone 16 to Cleanup and Stabilization for GUI

Files

modifiers_diff.txt 857 Bytes 07/25/2016 Sergey Ivanovskiy
